import org.multiverse.api.references.IntRef
import static org.multiverse.api.StmUtils.newIntRef
import static groovyx.gpars.stm.GParsStm.*
import static groovyx.gpars.dataflow.Dataflow.task

def count1 = newIntRef(0)
def count2 = newIntRef(100)


[Thread.start { atomic {
    println "modify...1"
    count1.set(count1.get() + 1)
    count2.set(count2.get() - 1)
  }},
  Thread.start { atomic {
    println "modify...2"
    count1.set(count1.get() + 1)
    count2.set(count2.get() - 1)
  }}]*.join()


println atomic { count1.get() }
println atomic { count2.get() }